"use strict";
exports.__esModule = true;
exports.defaultOptions = exports.REG = exports.catchFn = exports.thenFn = void 0;
var thenFn = function (data) { return function (resolve, reject) { return resolve(data); }; };
exports.thenFn = thenFn;
var catchFn = function (reject) { return function (err) { return reject(err) || console.trace(err); }; };
exports.catchFn = catchFn;
exports.REG = {
    ignored: /node_modules|(^|\\|\/)\./
};
exports.defaultOptions = {
    root: process.cwd(),
    watch: false,
    buildFilter: function (pathname) { return !exports.REG.ignored.test(pathname); },
    watchFilter: function (pathname) { return !exports.REG.ignored.test(pathname); },
    buildWatcher: function (pathname, eventType) { return console.log(new Date().toLocaleTimeString(), eventType, pathname); },
    onSet: function (pathname, data) { return new Promise(function (resolve, reject) { return resolve({ data: data, originPath: pathname, outputPath: pathname }); }); },
    onGet: function (pathname, data) { return new Promise(function (resolve, reject) { return resolve(data); }); },
    outputFilter: function (pathname) { return !/\btest\b/.test(pathname); }
};
