"use strict";
exports.__esModule = true;
var _ = require("lodash");
var utils_1 = require("./utils");
function default_1(options) {
    var onGet = options.onGet;
    var o = {};
    var buildings = 0;
    var listeners = [];
    var store = {
        isBuilding: function () { return buildings > 0; },
        onBuildingChange: function (listener) {
            listeners.push(listener);
        },
        setBuilding: function (n) {
            buildings = Math.max(buildings + n, 0);
            listeners.forEach(function (listener) { return listener(buildings > 0); });
        },
        _get: function (path) {
            return path ? _.get(o, utils_1.fixPathArr(path)) : o;
        },
        load: function (path) {
            return onGet(path, store._get(path), store);
        },
        _set: function (path, value) {
            path && _.set(o, utils_1.fixPathArr(path), value);
        },
        _reset: function () {
            o = {};
        }
    };
    return store;
}
exports["default"] = default_1;
